﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2021.2.3),
    on Mon 12 Sep 2022 02:21:44 PM
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
prefs.hardware['audioLib'] = 'ptb'
prefs.hardware['audioLatencyMode'] = '0'
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2021.2.3'
expName = 'melodylearning_workingbackup'  # from the Builder filename that created this script
expInfo = {'session': '001', 'participant': ''}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' %(expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/home/clasp/Desktop/Project_WL_MINT/MINT_2022/mint_reduced_lum_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color='-0.3333, -0.3412, -0.3333', colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Setup eyetracking
ioDevice = ioConfig = ioSession = ioServer = eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "welcomescreen"
welcomescreenClock = core.Clock()
minttxt = visual.TextStim(win=win, name='minttxt',
    text='Music in Noise Task \n(MINT)\n\n<press space to continue>',
    font='Open Sans',
    pos=[0, 0], height=0.15, wrapWidth=None, ori=0, 
    color=[0.1,1,0.1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
from vlc import libvlc_new
snrversion = randint(1,4)

from pylsl import StreamInfo, StreamOutlet
info = StreamInfo(name = 'MINT_triggers',
    type = 'Markers', channel_count = 1,
    channel_format = 'string', source_id = 'CL_MINT')
outlet = StreamOutlet(info)

text_8 = visual.TextStim(win=win, name='text_8',
    text=snrversion,
    font='Open Sans',
    pos=(0, -0.5), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);
key_resp_0 = keyboard.Keyboard()

# Initialize components for Routine "soundcheck"
soundcheckClock = core.Clock()
soundchecktext = visual.TextStim(win=win, name='soundchecktext',
    text="Please check that both sides \nof the headphones are working.\n \nPress 'n' when finished.",
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
sound_1 = sound.Sound('./Stimuli/soundcheck/SoundLevelTest_chopin-9-1-stahlbrand.ogg', secs=-1, stereo=True, hamming=True,
    name='sound_1')
sound_1.setVolume(100)
key_resp_5 = keyboard.Keyboard()

# Initialize components for Routine "famil_mel"
famil_melClock = core.Clock()
text = visual.TextStim(win=win, name='text',
    text="We will play you two short musical excerpts. One of them will be played in background noise.\n\nYour task is to determine if the two melodies match or mismatch. This is a practice round, so we'll tell you if you are correct or not.\n\n<press a key to continue>",
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_6 = keyboard.Keyboard()

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "melfamil"
melfamilClock = core.Clock()
ISI_2 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_2')
melfamil_1 = sound.Sound('A', secs=-1, stereo=True, hamming=True,
    name='melfamil_1')
melfamil_1.setVolume(100)
fixation_1 = visual.TextStim(win=win, name='fixation_1',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "press_1"
press_1Clock = core.Clock()
response_1 = keyboard.Keyboard()
text_10 = visual.TextStim(win=win, name='text_10',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "demofeedback"
demofeedbackClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_1 = visual.TextStim(win=win, name='feedback_1',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "famil_pred"
famil_predClock = core.Clock()
text_2 = visual.TextStim(win=win, name='text_2',
    text="Sometimes we'll play the melody without the background noise before the one with noise.\n\nYour task is still to determine if the two melodies match or mismatch. This is a practice round, so we'll tell you if you are correct or not.\n\n<press a key to continue>",
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_7 = keyboard.Keyboard()

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "predfamil"
predfamilClock = core.Clock()
ISI_9 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_9')
melfamil_2 = sound.Sound('A', secs=-1, stereo=True, hamming=True,
    name='melfamil_2')
melfamil_2.setVolume(100)
fixation_2 = visual.TextStim(win=win, name='fixation_2',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "press_2"
press_2Clock = core.Clock()
response_2 = keyboard.Keyboard()
text_11 = visual.TextStim(win=win, name='text_11',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "demofeedback_pred"
demofeedback_predClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_3 = visual.TextStim(win=win, name='feedback_3',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "famil_rhyth"
famil_rhythClock = core.Clock()
text_4 = visual.TextStim(win=win, name='text_4',
    text="Sometimes, you'll hear only one note, played rhythmically.\n\nYour task is still to determine if the two melodies match or mismatch. \n\n<press a key to continue>",
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_9 = keyboard.Keyboard()

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "rhythmfamil"
rhythmfamilClock = core.Clock()
ISI_11 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_11')
melfamil_4 = sound.Sound('A', secs=-1, stereo=True, hamming=True,
    name='melfamil_4')
melfamil_4.setVolume(100)
fixation_3 = visual.TextStim(win=win, name='fixation_3',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "press_3"
press_3Clock = core.Clock()
response_10 = keyboard.Keyboard()
text_12 = visual.TextStim(win=win, name='text_12',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "demofeedback_rhyth"
demofeedback_rhythClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_8 = visual.TextStim(win=win, name='feedback_8',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "famil_spatial"
famil_spatialClock = core.Clock()
text_5 = visual.TextStim(win=win, name='text_5',
    text="Sometimes, you'll hear the melody louder in one one ear than the other.\n\nAn icon will indicate the direction to listen in.\n\nYour task is still to determine if the two melodies match or mismatch. \n\n<press a key to continue>",
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_10 = keyboard.Keyboard()

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "spatialfamil"
spatialfamilClock = core.Clock()
ISI_12 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_12')
fixation_4 = visual.TextStim(win=win, name='fixation_4',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "press_4"
press_4Clock = core.Clock()
response_11 = keyboard.Keyboard()
text_13 = visual.TextStim(win=win, name='text_13',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "demofeedback_spat"
demofeedback_spatClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_9 = visual.TextStim(win=win, name='feedback_9',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "famil_visual"
famil_visualClock = core.Clock()
text_7 = visual.TextStim(win=win, name='text_7',
    text='Sometimes, the notes will be represented visually.\n\nYour task is still to determine if the two melodies match or mismatch. \n\n<press a key to continue>',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_12 = keyboard.Keyboard()

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "visualfamil"
visualfamilClock = core.Clock()
ISI_13 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_13')
fixation_5 = visual.TextStim(win=win, name='fixation_5',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "press_5"
press_5Clock = core.Clock()
response_12 = keyboard.Keyboard()
text_14 = visual.TextStim(win=win, name='text_14',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "demofeedback_vis"
demofeedback_visClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_10 = visual.TextStim(win=win, name='feedback_10',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "txt_mel"
txt_melClock = core.Clock()
text_9 = visual.TextStim(win=win, name='text_9',
    text='MAIN TASK\n\nThere will be no feedback this time!\n\nYou may take a break now if you wish.\n\n<press a key to continue>',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[0.1,1,0.1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp_13 = keyboard.Keyboard()

# Initialize components for Routine "randomizer"
randomizerClock = core.Clock()
order=[1,0,0,0,1,0,0,0,1]

import random

turn=[0,1,2]
random.shuffle(turn)

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "melmain"
melmainClock = core.Clock()
ISI_14 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_14')
melfamil_5 = sound.Sound('A', secs=-1, stereo=True, hamming=True,
    name='melfamil_5')
melfamil_5.setVolume(100)
fixation_6 = visual.TextStim(win=win, name='fixation_6',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "press_6"
press_6Clock = core.Clock()
response_13 = keyboard.Keyboard()
text_15 = visual.TextStim(win=win, name='text_15',
    text="Press 'q' for match and 'p' for mismatch\n",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "mainfeedback_mel"
mainfeedback_melClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_11 = visual.TextStim(win=win, name='feedback_11',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "predictmain"
predictmainClock = core.Clock()
ISI_15 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_15')
melfamil_6 = sound.Sound('A', secs=-1, stereo=True, hamming=True,
    name='melfamil_6')
melfamil_6.setVolume(100)
fixation_7 = visual.TextStim(win=win, name='fixation_7',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "press_7"
press_7Clock = core.Clock()
response_14 = keyboard.Keyboard()
text_20 = visual.TextStim(win=win, name='text_20',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "mainfeedback_predict"
mainfeedback_predictClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_12 = visual.TextStim(win=win, name='feedback_12',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "basefix"
basefixClock = core.Clock()
text_19 = visual.TextStim(win=win, name='text_19',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "visualmain"
visualmainClock = core.Clock()
ISI_18 = clock.StaticPeriod(win=win, screenHz=expInfo['frameRate'], name='ISI_18')
fixation_10 = visual.TextStim(win=win, name='fixation_10',
    text='+',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "press_10"
press_10Clock = core.Clock()
response_17 = keyboard.Keyboard()
text_18 = visual.TextStim(win=win, name='text_18',
    text="Press 'q' for match and 'p' for mismatch",
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "mainfeedback_visual"
mainfeedback_visualClock = core.Clock()
#msg variable just needs some value at start
msg=''

feedback_15 = visual.TextStim(win=win, name='feedback_15',
    text='',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color=[1,1,1], colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "deleter"
deleterClock = core.Clock()

# Initialize components for Routine "finaltext"
finaltextClock = core.Clock()
endtext = visual.TextStim(win=win, name='endtext',
    text='Experiment complete!\n\nThank you! ',
    font='Open Sans',
    pos=[0, 0], height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "welcomescreen"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_0.keys = []
key_resp_0.rt = []
_key_resp_0_allKeys = []
# keep track of which components have finished
welcomescreenComponents = [minttxt, text_8, key_resp_0]
for thisComponent in welcomescreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
welcomescreenClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "welcomescreen"-------
while continueRoutine:
    # get current time
    t = welcomescreenClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=welcomescreenClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *minttxt* updates
    if minttxt.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        minttxt.frameNStart = frameN  # exact frame index
        minttxt.tStart = t  # local t and not account for scr refresh
        minttxt.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(minttxt, 'tStartRefresh')  # time at next scr refresh
        minttxt.setAutoDraw(True)
    
    # *text_8* updates
    if text_8.status == NOT_STARTED and tThisFlip >= 1-frameTolerance:
        # keep track of start time/frame for later
        text_8.frameNStart = frameN  # exact frame index
        text_8.tStart = t  # local t and not account for scr refresh
        text_8.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_8, 'tStartRefresh')  # time at next scr refresh
        text_8.setAutoDraw(True)
    if text_8.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > text_8.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            text_8.tStop = t  # not accounting for scr refresh
            text_8.frameNStop = frameN  # exact frame index
            win.timeOnFlip(text_8, 'tStopRefresh')  # time at next scr refresh
            text_8.setAutoDraw(False)
    
    # *key_resp_0* updates
    if key_resp_0.status == NOT_STARTED and t >= 1.5-frameTolerance:
        # keep track of start time/frame for later
        key_resp_0.frameNStart = frameN  # exact frame index
        key_resp_0.tStart = t  # local t and not account for scr refresh
        key_resp_0.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_0, 'tStartRefresh')  # time at next scr refresh
        key_resp_0.status = STARTED
        # keyboard checking is just starting
        key_resp_0.clock.reset()  # now t=0
        key_resp_0.clearEvents(eventType='keyboard')
    if key_resp_0.status == STARTED:
        theseKeys = key_resp_0.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_0_allKeys.extend(theseKeys)
        if len(_key_resp_0_allKeys):
            key_resp_0.keys = _key_resp_0_allKeys[-1].name  # just the last key pressed
            key_resp_0.rt = _key_resp_0_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in welcomescreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "welcomescreen"-------
for thisComponent in welcomescreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('minttxt.started', minttxt.tStartRefresh)
thisExp.addData('minttxt.stopped', minttxt.tStopRefresh)
# the Routine "welcomescreen" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
SKIP = data.TrialHandler(nReps=0.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='SKIP')
thisExp.addLoop(SKIP)  # add the loop to the experiment
thisSKIP = SKIP.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisSKIP.rgb)
if thisSKIP != None:
    for paramName in thisSKIP:
        exec('{} = thisSKIP[paramName]'.format(paramName))

for thisSKIP in SKIP:
    currentLoop = SKIP
    # abbreviate parameter names if possible (e.g. rgb = thisSKIP.rgb)
    if thisSKIP != None:
        for paramName in thisSKIP:
            exec('{} = thisSKIP[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "soundcheck"-------
    continueRoutine = True
    # update component parameters for each repeat
    sound_1.setSound('./Stimuli/soundcheck/SoundLevelTest_chopin-9-1-stahlbrand.ogg', hamming=True)
    sound_1.setVolume(100, log=False)
    key_resp_5.keys = []
    key_resp_5.rt = []
    _key_resp_5_allKeys = []
    outlet.push_sample(x=['sound check'])
    # keep track of which components have finished
    soundcheckComponents = [soundchecktext, sound_1, key_resp_5]
    for thisComponent in soundcheckComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    soundcheckClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "soundcheck"-------
    while continueRoutine:
        # get current time
        t = soundcheckClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=soundcheckClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *soundchecktext* updates
        if soundchecktext.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            soundchecktext.frameNStart = frameN  # exact frame index
            soundchecktext.tStart = t  # local t and not account for scr refresh
            soundchecktext.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(soundchecktext, 'tStartRefresh')  # time at next scr refresh
            soundchecktext.setAutoDraw(True)
        # start/stop sound_1
        if sound_1.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
            # keep track of start time/frame for later
            sound_1.frameNStart = frameN  # exact frame index
            sound_1.tStart = t  # local t and not account for scr refresh
            sound_1.tStartRefresh = tThisFlipGlobal  # on global time
            sound_1.play(when=win)  # sync with win flip
        
        # *key_resp_5* updates
        waitOnFlip = False
        if key_resp_5.status == NOT_STARTED and tThisFlip >= 1-frameTolerance:
            # keep track of start time/frame for later
            key_resp_5.frameNStart = frameN  # exact frame index
            key_resp_5.tStart = t  # local t and not account for scr refresh
            key_resp_5.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_5, 'tStartRefresh')  # time at next scr refresh
            key_resp_5.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_5.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_5.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_5.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_5.getKeys(keyList=['n'], waitRelease=False)
            _key_resp_5_allKeys.extend(theseKeys)
            if len(_key_resp_5_allKeys):
                key_resp_5.keys = _key_resp_5_allKeys[-1].name  # just the last key pressed
                key_resp_5.rt = _key_resp_5_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in soundcheckComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "soundcheck"-------
    for thisComponent in soundcheckComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('soundchecktext.started', soundchecktext.tStartRefresh)
    SKIP.addData('soundchecktext.stopped', soundchecktext.tStopRefresh)
    sound_1.stop()  # ensure sound has stopped at end of routine
    SKIP.addData('sound_1.started', sound_1.tStartRefresh)
    SKIP.addData('sound_1.stopped', sound_1.tStopRefresh)
    # the Routine "soundcheck" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "famil_mel"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_6.keys = []
    key_resp_6.rt = []
    _key_resp_6_allKeys = []
    # keep track of which components have finished
    famil_melComponents = [text, key_resp_6]
    for thisComponent in famil_melComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    famil_melClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "famil_mel"-------
    while continueRoutine:
        # get current time
        t = famil_melClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=famil_melClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text* updates
        if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text.frameNStart = frameN  # exact frame index
            text.tStart = t  # local t and not account for scr refresh
            text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
            text.setAutoDraw(True)
        
        # *key_resp_6* updates
        waitOnFlip = False
        if key_resp_6.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_6.frameNStart = frameN  # exact frame index
            key_resp_6.tStart = t  # local t and not account for scr refresh
            key_resp_6.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_6, 'tStartRefresh')  # time at next scr refresh
            key_resp_6.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_6.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_6.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_6.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_6.getKeys(keyList=None, waitRelease=False)
            _key_resp_6_allKeys.extend(theseKeys)
            if len(_key_resp_6_allKeys):
                key_resp_6.keys = _key_resp_6_allKeys[-1].name  # just the last key pressed
                key_resp_6.rt = _key_resp_6_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in famil_melComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "famil_mel"-------
    for thisComponent in famil_melComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text.started', text.tStartRefresh)
    SKIP.addData('text.stopped', text.tStopRefresh)
    # the Routine "famil_mel" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    audiodemos = data.TrialHandler(nReps=1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_famil_mel.xlsx'),
        seed=None, name='audiodemos')
    thisExp.addLoop(audiodemos)  # add the loop to the experiment
    thisAudiodemo = audiodemos.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisAudiodemo.rgb)
    if thisAudiodemo != None:
        for paramName in thisAudiodemo:
            exec('{} = thisAudiodemo[paramName]'.format(paramName))
    
    for thisAudiodemo in audiodemos:
        currentLoop = audiodemos
        # abbreviate parameter names if possible (e.g. rgb = thisAudiodemo.rgb)
        if thisAudiodemo != None:
            for paramName in thisAudiodemo:
                exec('{} = thisAudiodemo[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        audiodemos.addData('text_19.started', text_19.tStartRefresh)
        audiodemos.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "melfamil"-------
        continueRoutine = True
        # update component parameters for each repeat
        melfamil_1.setSound(melfile, hamming=True)
        melfamil_1.setVolume(100, log=False)
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['practice_baseline_start_'+thisfile])
        
        # keep track of which components have finished
        melfamilComponents = [ISI_2, melfamil_1, fixation_1]
        for thisComponent in melfamilComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        melfamilClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "melfamil"-------
        while continueRoutine:
            # get current time
            t = melfamilClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=melfamilClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # start/stop melfamil_1
            if melfamil_1.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                melfamil_1.frameNStart = frameN  # exact frame index
                melfamil_1.tStart = t  # local t and not account for scr refresh
                melfamil_1.tStartRefresh = tThisFlipGlobal  # on global time
                melfamil_1.play(when=win)  # sync with win flip
            
            # *fixation_1* updates
            if fixation_1.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_1.frameNStart = frameN  # exact frame index
                fixation_1.tStart = t  # local t and not account for scr refresh
                fixation_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_1, 'tStartRefresh')  # time at next scr refresh
                fixation_1.setAutoDraw(True)
            if fixation_1.status == STARTED:
                if bool(melfamil_1.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_1.tStop = t  # not accounting for scr refresh
                    fixation_1.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_1, 'tStopRefresh')  # time at next scr refresh
                    fixation_1.setAutoDraw(False)
            # *ISI_2* period
            if ISI_2.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_2.frameNStart = frameN  # exact frame index
                ISI_2.tStart = t  # local t and not account for scr refresh
                ISI_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_2, 'tStartRefresh')  # time at next scr refresh
                ISI_2.start(0.5)
            elif ISI_2.status == STARTED:  # one frame should pass before updating params and completing
                ISI_2.complete()  # finish the static period
                ISI_2.tStop = ISI_2.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in melfamilComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "melfamil"-------
        for thisComponent in melfamilComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        audiodemos.addData('ISI_2.started', ISI_2.tStart)
        audiodemos.addData('ISI_2.stopped', ISI_2.tStop)
        melfamil_1.stop()  # ensure sound has stopped at end of routine
        audiodemos.addData('melfamil_1.started', melfamil_1.tStartRefresh)
        audiodemos.addData('melfamil_1.stopped', melfamil_1.tStopRefresh)
        audiodemos.addData('fixation_1.started', fixation_1.tStartRefresh)
        audiodemos.addData('fixation_1.stopped', fixation_1.tStopRefresh)
        outlet.push_sample(x=['practice_baseline_end_'+thisfile])
        # the Routine "melfamil" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_1"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_1.keys = []
        response_1.rt = []
        _response_1_allKeys = []
        # keep track of which components have finished
        press_1Components = [response_1, text_10]
        for thisComponent in press_1Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_1"-------
        while continueRoutine:
            # get current time
            t = press_1Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_1Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_1* updates
            waitOnFlip = False
            if response_1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_1.frameNStart = frameN  # exact frame index
                response_1.tStart = t  # local t and not account for scr refresh
                response_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_1, 'tStartRefresh')  # time at next scr refresh
                response_1.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_1.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_1.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_1.status == STARTED and not waitOnFlip:
                theseKeys = response_1.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_1_allKeys.extend(theseKeys)
                if len(_response_1_allKeys):
                    response_1.keys = _response_1_allKeys[-1].name  # just the last key pressed
                    response_1.rt = _response_1_allKeys[-1].rt
                    # was this correct?
                    if (response_1.keys == str(corrAns)) or (response_1.keys == corrAns):
                        response_1.corr = 1
                    else:
                        response_1.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_10* updates
            if text_10.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_10.frameNStart = frameN  # exact frame index
                text_10.tStart = t  # local t and not account for scr refresh
                text_10.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_10, 'tStartRefresh')  # time at next scr refresh
                text_10.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_1Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_1"-------
        for thisComponent in press_1Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        audiodemos.addData('text_10.started', text_10.tStartRefresh)
        audiodemos.addData('text_10.stopped', text_10.tStopRefresh)
        # the Routine "press_1" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "demofeedback"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_1.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_1.setColor([0,1,0])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_1.setColor([1,0,0])
          outlet.push_sample(x=['responsewrong'])
        
        
        feedback_1.setText(msg)
        # keep track of which components have finished
        demofeedbackComponents = [feedback_1]
        for thisComponent in demofeedbackComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        demofeedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "demofeedback"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = demofeedbackClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=demofeedbackClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_1* updates
            if feedback_1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_1.frameNStart = frameN  # exact frame index
                feedback_1.tStart = t  # local t and not account for scr refresh
                feedback_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_1, 'tStartRefresh')  # time at next scr refresh
                feedback_1.setAutoDraw(True)
            if feedback_1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_1.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_1.tStop = t  # not accounting for scr refresh
                    feedback_1.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_1, 'tStopRefresh')  # time at next scr refresh
                    feedback_1.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in demofeedbackComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "demofeedback"-------
        for thisComponent in demofeedbackComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        audiodemos.addData('feedback_1.started', feedback_1.tStartRefresh)
        audiodemos.addData('feedback_1.stopped', feedback_1.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'audiodemos'
    
    # get names of stimulus parameters
    if audiodemos.trialList in ([], [None], None):
        params = []
    else:
        params = audiodemos.trialList[0].keys()
    # save data for this loop
    audiodemos.saveAsExcel(filename + '.xlsx', sheetName='audiodemos',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    audiodemos.saveAsText(filename + 'audiodemos.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "famil_pred"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_7.keys = []
    key_resp_7.rt = []
    _key_resp_7_allKeys = []
    # keep track of which components have finished
    famil_predComponents = [text_2, key_resp_7]
    for thisComponent in famil_predComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    famil_predClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "famil_pred"-------
    while continueRoutine:
        # get current time
        t = famil_predClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=famil_predClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_2* updates
        if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_2.frameNStart = frameN  # exact frame index
            text_2.tStart = t  # local t and not account for scr refresh
            text_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
            text_2.setAutoDraw(True)
        
        # *key_resp_7* updates
        waitOnFlip = False
        if key_resp_7.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_7.frameNStart = frameN  # exact frame index
            key_resp_7.tStart = t  # local t and not account for scr refresh
            key_resp_7.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_7, 'tStartRefresh')  # time at next scr refresh
            key_resp_7.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_7.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_7.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_7.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_7.getKeys(keyList=None, waitRelease=False)
            _key_resp_7_allKeys.extend(theseKeys)
            if len(_key_resp_7_allKeys):
                key_resp_7.keys = _key_resp_7_allKeys[-1].name  # just the last key pressed
                key_resp_7.rt = _key_resp_7_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in famil_predComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "famil_pred"-------
    for thisComponent in famil_predComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text_2.started', text_2.tStartRefresh)
    SKIP.addData('text_2.stopped', text_2.tStopRefresh)
    # the Routine "famil_pred" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trials_3 = data.TrialHandler(nReps=1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_famil_pred.xlsx'),
        seed=None, name='trials_3')
    thisExp.addLoop(trials_3)  # add the loop to the experiment
    thisTrial_3 = trials_3.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
    if thisTrial_3 != None:
        for paramName in thisTrial_3:
            exec('{} = thisTrial_3[paramName]'.format(paramName))
    
    for thisTrial_3 in trials_3:
        currentLoop = trials_3
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
        if thisTrial_3 != None:
            for paramName in thisTrial_3:
                exec('{} = thisTrial_3[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_3.addData('text_19.started', text_19.tStartRefresh)
        trials_3.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "predfamil"-------
        continueRoutine = True
        # update component parameters for each repeat
        melfamil_2.setSound(melfile, hamming=True)
        melfamil_2.setVolume(100, log=False)
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['practice_predition_start_'+thisfile])
        # keep track of which components have finished
        predfamilComponents = [ISI_9, melfamil_2, fixation_2]
        for thisComponent in predfamilComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        predfamilClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "predfamil"-------
        while continueRoutine:
            # get current time
            t = predfamilClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=predfamilClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # start/stop melfamil_2
            if melfamil_2.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                melfamil_2.frameNStart = frameN  # exact frame index
                melfamil_2.tStart = t  # local t and not account for scr refresh
                melfamil_2.tStartRefresh = tThisFlipGlobal  # on global time
                melfamil_2.play(when=win)  # sync with win flip
            
            # *fixation_2* updates
            if fixation_2.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_2.frameNStart = frameN  # exact frame index
                fixation_2.tStart = t  # local t and not account for scr refresh
                fixation_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_2, 'tStartRefresh')  # time at next scr refresh
                fixation_2.setAutoDraw(True)
            if fixation_2.status == STARTED:
                if bool(melfamil_2.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_2.tStop = t  # not accounting for scr refresh
                    fixation_2.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_2, 'tStopRefresh')  # time at next scr refresh
                    fixation_2.setAutoDraw(False)
            # *ISI_9* period
            if ISI_9.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_9.frameNStart = frameN  # exact frame index
                ISI_9.tStart = t  # local t and not account for scr refresh
                ISI_9.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_9, 'tStartRefresh')  # time at next scr refresh
                ISI_9.start(0.5)
            elif ISI_9.status == STARTED:  # one frame should pass before updating params and completing
                ISI_9.complete()  # finish the static period
                ISI_9.tStop = ISI_9.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in predfamilComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "predfamil"-------
        for thisComponent in predfamilComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_3.addData('ISI_9.started', ISI_9.tStart)
        trials_3.addData('ISI_9.stopped', ISI_9.tStop)
        melfamil_2.stop()  # ensure sound has stopped at end of routine
        trials_3.addData('melfamil_2.started', melfamil_2.tStartRefresh)
        trials_3.addData('melfamil_2.stopped', melfamil_2.tStopRefresh)
        trials_3.addData('fixation_2.started', fixation_2.tStartRefresh)
        trials_3.addData('fixation_2.stopped', fixation_2.tStopRefresh)
        outlet.push_sample(x=['practice_predition_end_'+thisfile])
        # the Routine "predfamil" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_2"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_2.keys = []
        response_2.rt = []
        _response_2_allKeys = []
        # keep track of which components have finished
        press_2Components = [response_2, text_11]
        for thisComponent in press_2Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_2"-------
        while continueRoutine:
            # get current time
            t = press_2Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_2Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_2* updates
            waitOnFlip = False
            if response_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_2.frameNStart = frameN  # exact frame index
                response_2.tStart = t  # local t and not account for scr refresh
                response_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_2, 'tStartRefresh')  # time at next scr refresh
                response_2.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_2.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_2.status == STARTED and not waitOnFlip:
                theseKeys = response_2.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_2_allKeys.extend(theseKeys)
                if len(_response_2_allKeys):
                    response_2.keys = _response_2_allKeys[-1].name  # just the last key pressed
                    response_2.rt = _response_2_allKeys[-1].rt
                    # was this correct?
                    if (response_2.keys == str(corrAns)) or (response_2.keys == corrAns):
                        response_2.corr = 1
                    else:
                        response_2.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_11* updates
            if text_11.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_11.frameNStart = frameN  # exact frame index
                text_11.tStart = t  # local t and not account for scr refresh
                text_11.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_11, 'tStartRefresh')  # time at next scr refresh
                text_11.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_2"-------
        for thisComponent in press_2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_3.addData('text_11.started', text_11.tStartRefresh)
        trials_3.addData('text_11.stopped', text_11.tStopRefresh)
        # the Routine "press_2" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "demofeedback_pred"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_2.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_3.setColor([0,1,0])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_3.setColor([1,0,0])
          outlet.push_sample(x=['responsewrong'])
        
        feedback_3.setText(msg)
        # keep track of which components have finished
        demofeedback_predComponents = [feedback_3]
        for thisComponent in demofeedback_predComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        demofeedback_predClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "demofeedback_pred"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = demofeedback_predClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=demofeedback_predClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_3* updates
            if feedback_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_3.frameNStart = frameN  # exact frame index
                feedback_3.tStart = t  # local t and not account for scr refresh
                feedback_3.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_3, 'tStartRefresh')  # time at next scr refresh
                feedback_3.setAutoDraw(True)
            if feedback_3.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_3.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_3.tStop = t  # not accounting for scr refresh
                    feedback_3.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_3, 'tStopRefresh')  # time at next scr refresh
                    feedback_3.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in demofeedback_predComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "demofeedback_pred"-------
        for thisComponent in demofeedback_predComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_3.addData('feedback_3.started', feedback_3.tStartRefresh)
        trials_3.addData('feedback_3.stopped', feedback_3.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'trials_3'
    
    # get names of stimulus parameters
    if trials_3.trialList in ([], [None], None):
        params = []
    else:
        params = trials_3.trialList[0].keys()
    # save data for this loop
    trials_3.saveAsExcel(filename + '.xlsx', sheetName='trials_3',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_3.saveAsText(filename + 'trials_3.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "famil_rhyth"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_9.keys = []
    key_resp_9.rt = []
    _key_resp_9_allKeys = []
    # keep track of which components have finished
    famil_rhythComponents = [text_4, key_resp_9]
    for thisComponent in famil_rhythComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    famil_rhythClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "famil_rhyth"-------
    while continueRoutine:
        # get current time
        t = famil_rhythClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=famil_rhythClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_4* updates
        if text_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_4.frameNStart = frameN  # exact frame index
            text_4.tStart = t  # local t and not account for scr refresh
            text_4.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_4, 'tStartRefresh')  # time at next scr refresh
            text_4.setAutoDraw(True)
        
        # *key_resp_9* updates
        waitOnFlip = False
        if key_resp_9.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_9.frameNStart = frameN  # exact frame index
            key_resp_9.tStart = t  # local t and not account for scr refresh
            key_resp_9.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_9, 'tStartRefresh')  # time at next scr refresh
            key_resp_9.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_9.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_9.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_9.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_9.getKeys(keyList=None, waitRelease=False)
            _key_resp_9_allKeys.extend(theseKeys)
            if len(_key_resp_9_allKeys):
                key_resp_9.keys = _key_resp_9_allKeys[-1].name  # just the last key pressed
                key_resp_9.rt = _key_resp_9_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in famil_rhythComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "famil_rhyth"-------
    for thisComponent in famil_rhythComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text_4.started', text_4.tStartRefresh)
    SKIP.addData('text_4.stopped', text_4.tStopRefresh)
    # the Routine "famil_rhyth" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trials_2 = data.TrialHandler(nReps=1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_famil_rhyth.xlsx'),
        seed=None, name='trials_2')
    thisExp.addLoop(trials_2)  # add the loop to the experiment
    thisTrial_2 = trials_2.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
    if thisTrial_2 != None:
        for paramName in thisTrial_2:
            exec('{} = thisTrial_2[paramName]'.format(paramName))
    
    for thisTrial_2 in trials_2:
        currentLoop = trials_2
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
        if thisTrial_2 != None:
            for paramName in thisTrial_2:
                exec('{} = thisTrial_2[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_2.addData('text_19.started', text_19.tStartRefresh)
        trials_2.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "rhythmfamil"-------
        continueRoutine = True
        # update component parameters for each repeat
        melfamil_4.setSound(melfile, hamming=True)
        melfamil_4.setVolume(100, log=False)
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['practice_rhythm_start_'+thisfile])
        # keep track of which components have finished
        rhythmfamilComponents = [ISI_11, melfamil_4, fixation_3]
        for thisComponent in rhythmfamilComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        rhythmfamilClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "rhythmfamil"-------
        while continueRoutine:
            # get current time
            t = rhythmfamilClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=rhythmfamilClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # start/stop melfamil_4
            if melfamil_4.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                melfamil_4.frameNStart = frameN  # exact frame index
                melfamil_4.tStart = t  # local t and not account for scr refresh
                melfamil_4.tStartRefresh = tThisFlipGlobal  # on global time
                melfamil_4.play(when=win)  # sync with win flip
            
            # *fixation_3* updates
            if fixation_3.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_3.frameNStart = frameN  # exact frame index
                fixation_3.tStart = t  # local t and not account for scr refresh
                fixation_3.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_3, 'tStartRefresh')  # time at next scr refresh
                fixation_3.setAutoDraw(True)
            if fixation_3.status == STARTED:
                if bool(melfamil_4.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_3.tStop = t  # not accounting for scr refresh
                    fixation_3.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_3, 'tStopRefresh')  # time at next scr refresh
                    fixation_3.setAutoDraw(False)
            # *ISI_11* period
            if ISI_11.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_11.frameNStart = frameN  # exact frame index
                ISI_11.tStart = t  # local t and not account for scr refresh
                ISI_11.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_11, 'tStartRefresh')  # time at next scr refresh
                ISI_11.start(0.5)
            elif ISI_11.status == STARTED:  # one frame should pass before updating params and completing
                ISI_11.complete()  # finish the static period
                ISI_11.tStop = ISI_11.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in rhythmfamilComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "rhythmfamil"-------
        for thisComponent in rhythmfamilComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_2.addData('ISI_11.started', ISI_11.tStart)
        trials_2.addData('ISI_11.stopped', ISI_11.tStop)
        melfamil_4.stop()  # ensure sound has stopped at end of routine
        trials_2.addData('melfamil_4.started', melfamil_4.tStartRefresh)
        trials_2.addData('melfamil_4.stopped', melfamil_4.tStopRefresh)
        trials_2.addData('fixation_3.started', fixation_3.tStartRefresh)
        trials_2.addData('fixation_3.stopped', fixation_3.tStopRefresh)
        outlet.push_sample(x=['practice_rhythm_end_'+thisfile])
        # the Routine "rhythmfamil" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_3"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_10.keys = []
        response_10.rt = []
        _response_10_allKeys = []
        # keep track of which components have finished
        press_3Components = [response_10, text_12]
        for thisComponent in press_3Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_3"-------
        while continueRoutine:
            # get current time
            t = press_3Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_3Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_10* updates
            waitOnFlip = False
            if response_10.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_10.frameNStart = frameN  # exact frame index
                response_10.tStart = t  # local t and not account for scr refresh
                response_10.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_10, 'tStartRefresh')  # time at next scr refresh
                response_10.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_10.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_10.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_10.status == STARTED and not waitOnFlip:
                theseKeys = response_10.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_10_allKeys.extend(theseKeys)
                if len(_response_10_allKeys):
                    response_10.keys = _response_10_allKeys[-1].name  # just the last key pressed
                    response_10.rt = _response_10_allKeys[-1].rt
                    # was this correct?
                    if (response_10.keys == str(corrAns)) or (response_10.keys == corrAns):
                        response_10.corr = 1
                    else:
                        response_10.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_12* updates
            if text_12.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_12.frameNStart = frameN  # exact frame index
                text_12.tStart = t  # local t and not account for scr refresh
                text_12.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_12, 'tStartRefresh')  # time at next scr refresh
                text_12.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_3Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_3"-------
        for thisComponent in press_3Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_2.addData('text_12.started', text_12.tStartRefresh)
        trials_2.addData('text_12.stopped', text_12.tStopRefresh)
        # the Routine "press_3" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "demofeedback_rhyth"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_10.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_8.setColor([0,1,0])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_8.setColor([1,0,0])
          outlet.push_sample(x=['responsewrong'])
        
        
        feedback_8.setText(msg)
        # keep track of which components have finished
        demofeedback_rhythComponents = [feedback_8]
        for thisComponent in demofeedback_rhythComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        demofeedback_rhythClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "demofeedback_rhyth"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = demofeedback_rhythClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=demofeedback_rhythClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_8* updates
            if feedback_8.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_8.frameNStart = frameN  # exact frame index
                feedback_8.tStart = t  # local t and not account for scr refresh
                feedback_8.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_8, 'tStartRefresh')  # time at next scr refresh
                feedback_8.setAutoDraw(True)
            if feedback_8.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_8.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_8.tStop = t  # not accounting for scr refresh
                    feedback_8.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_8, 'tStopRefresh')  # time at next scr refresh
                    feedback_8.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in demofeedback_rhythComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "demofeedback_rhyth"-------
        for thisComponent in demofeedback_rhythComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_2.addData('feedback_8.started', feedback_8.tStartRefresh)
        trials_2.addData('feedback_8.stopped', feedback_8.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'trials_2'
    
    # get names of stimulus parameters
    if trials_2.trialList in ([], [None], None):
        params = []
    else:
        params = trials_2.trialList[0].keys()
    # save data for this loop
    trials_2.saveAsExcel(filename + '.xlsx', sheetName='trials_2',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_2.saveAsText(filename + 'trials_2.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "famil_spatial"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_10.keys = []
    key_resp_10.rt = []
    _key_resp_10_allKeys = []
    # keep track of which components have finished
    famil_spatialComponents = [text_5, key_resp_10]
    for thisComponent in famil_spatialComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    famil_spatialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "famil_spatial"-------
    while continueRoutine:
        # get current time
        t = famil_spatialClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=famil_spatialClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_5* updates
        if text_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_5.frameNStart = frameN  # exact frame index
            text_5.tStart = t  # local t and not account for scr refresh
            text_5.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_5, 'tStartRefresh')  # time at next scr refresh
            text_5.setAutoDraw(True)
        
        # *key_resp_10* updates
        waitOnFlip = False
        if key_resp_10.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_10.frameNStart = frameN  # exact frame index
            key_resp_10.tStart = t  # local t and not account for scr refresh
            key_resp_10.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_10, 'tStartRefresh')  # time at next scr refresh
            key_resp_10.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_10.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_10.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_10.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_10.getKeys(keyList=None, waitRelease=False)
            _key_resp_10_allKeys.extend(theseKeys)
            if len(_key_resp_10_allKeys):
                key_resp_10.keys = _key_resp_10_allKeys[-1].name  # just the last key pressed
                key_resp_10.rt = _key_resp_10_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in famil_spatialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "famil_spatial"-------
    for thisComponent in famil_spatialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text_5.started', text_5.tStartRefresh)
    SKIP.addData('text_5.stopped', text_5.tStopRefresh)
    # the Routine "famil_spatial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trials_4 = data.TrialHandler(nReps=1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_famil_spat.xlsx'),
        seed=None, name='trials_4')
    thisExp.addLoop(trials_4)  # add the loop to the experiment
    thisTrial_4 = trials_4.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
    if thisTrial_4 != None:
        for paramName in thisTrial_4:
            exec('{} = thisTrial_4[paramName]'.format(paramName))
    
    for thisTrial_4 in trials_4:
        currentLoop = trials_4
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
        if thisTrial_4 != None:
            for paramName in thisTrial_4:
                exec('{} = thisTrial_4[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_4.addData('text_19.started', text_19.tStartRefresh)
        trials_4.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "spatialfamil"-------
        continueRoutine = True
        # update component parameters for each repeat
        movie_1 = visual.MovieStim3(
            win=win, name='movie_1',units='height', 
            noAudio = False,
            filename=melfile,
            ori=0, pos=[0, 0], opacity=1,
            loop=False,
            size=[1.4,0.9],
            depth=-2.0,
            )
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['practice_spatial_start_'+thisfile])
        # keep track of which components have finished
        spatialfamilComponents = [ISI_12, fixation_4, movie_1]
        for thisComponent in spatialfamilComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        spatialfamilClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "spatialfamil"-------
        while continueRoutine:
            # get current time
            t = spatialfamilClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=spatialfamilClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation_4* updates
            if fixation_4.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_4.frameNStart = frameN  # exact frame index
                fixation_4.tStart = t  # local t and not account for scr refresh
                fixation_4.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_4, 'tStartRefresh')  # time at next scr refresh
                fixation_4.setAutoDraw(True)
            if fixation_4.status == STARTED:
                if bool(movie_1.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_4.tStop = t  # not accounting for scr refresh
                    fixation_4.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_4, 'tStopRefresh')  # time at next scr refresh
                    fixation_4.setAutoDraw(False)
            
            # *movie_1* updates
            if movie_1.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                movie_1.frameNStart = frameN  # exact frame index
                movie_1.tStart = t  # local t and not account for scr refresh
                movie_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(movie_1, 'tStartRefresh')  # time at next scr refresh
                movie_1.setAutoDraw(True)
            # *ISI_12* period
            if ISI_12.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_12.frameNStart = frameN  # exact frame index
                ISI_12.tStart = t  # local t and not account for scr refresh
                ISI_12.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_12, 'tStartRefresh')  # time at next scr refresh
                ISI_12.start(0.5)
            elif ISI_12.status == STARTED:  # one frame should pass before updating params and completing
                ISI_12.complete()  # finish the static period
                ISI_12.tStop = ISI_12.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in spatialfamilComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "spatialfamil"-------
        for thisComponent in spatialfamilComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_4.addData('ISI_12.started', ISI_12.tStart)
        trials_4.addData('ISI_12.stopped', ISI_12.tStop)
        trials_4.addData('fixation_4.started', fixation_4.tStartRefresh)
        trials_4.addData('fixation_4.stopped', fixation_4.tStopRefresh)
        movie_1.stop()
        outlet.push_sample(x=['practice_spatial_end_'+thisfile])
        # the Routine "spatialfamil" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_4"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_11.keys = []
        response_11.rt = []
        _response_11_allKeys = []
        # keep track of which components have finished
        press_4Components = [response_11, text_13]
        for thisComponent in press_4Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_4Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_4"-------
        while continueRoutine:
            # get current time
            t = press_4Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_4Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_11* updates
            waitOnFlip = False
            if response_11.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_11.frameNStart = frameN  # exact frame index
                response_11.tStart = t  # local t and not account for scr refresh
                response_11.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_11, 'tStartRefresh')  # time at next scr refresh
                response_11.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_11.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_11.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_11.status == STARTED and not waitOnFlip:
                theseKeys = response_11.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_11_allKeys.extend(theseKeys)
                if len(_response_11_allKeys):
                    response_11.keys = _response_11_allKeys[-1].name  # just the last key pressed
                    response_11.rt = _response_11_allKeys[-1].rt
                    # was this correct?
                    if (response_11.keys == str(corrAns)) or (response_11.keys == corrAns):
                        response_11.corr = 1
                    else:
                        response_11.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_13* updates
            if text_13.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_13.frameNStart = frameN  # exact frame index
                text_13.tStart = t  # local t and not account for scr refresh
                text_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_13, 'tStartRefresh')  # time at next scr refresh
                text_13.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_4Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_4"-------
        for thisComponent in press_4Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_4.addData('text_13.started', text_13.tStartRefresh)
        trials_4.addData('text_13.stopped', text_13.tStopRefresh)
        # the Routine "press_4" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "demofeedback_spat"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_11.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_9.setColor([0,1,0])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_9.setColor([1,0,0])
          outlet.push_sample(x=['responsewrong'])
        
        feedback_9.setText(msg)
        # keep track of which components have finished
        demofeedback_spatComponents = [feedback_9]
        for thisComponent in demofeedback_spatComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        demofeedback_spatClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "demofeedback_spat"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = demofeedback_spatClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=demofeedback_spatClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_9* updates
            if feedback_9.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_9.frameNStart = frameN  # exact frame index
                feedback_9.tStart = t  # local t and not account for scr refresh
                feedback_9.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_9, 'tStartRefresh')  # time at next scr refresh
                feedback_9.setAutoDraw(True)
            if feedback_9.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_9.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_9.tStop = t  # not accounting for scr refresh
                    feedback_9.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_9, 'tStopRefresh')  # time at next scr refresh
                    feedback_9.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in demofeedback_spatComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "demofeedback_spat"-------
        for thisComponent in demofeedback_spatComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_4.addData('feedback_9.started', feedback_9.tStartRefresh)
        trials_4.addData('feedback_9.stopped', feedback_9.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'trials_4'
    
    # get names of stimulus parameters
    if trials_4.trialList in ([], [None], None):
        params = []
    else:
        params = trials_4.trialList[0].keys()
    # save data for this loop
    trials_4.saveAsExcel(filename + '.xlsx', sheetName='trials_4',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_4.saveAsText(filename + 'trials_4.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "famil_visual"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_12.keys = []
    key_resp_12.rt = []
    _key_resp_12_allKeys = []
    # keep track of which components have finished
    famil_visualComponents = [text_7, key_resp_12]
    for thisComponent in famil_visualComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    famil_visualClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "famil_visual"-------
    while continueRoutine:
        # get current time
        t = famil_visualClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=famil_visualClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_7* updates
        if text_7.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_7.frameNStart = frameN  # exact frame index
            text_7.tStart = t  # local t and not account for scr refresh
            text_7.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_7, 'tStartRefresh')  # time at next scr refresh
            text_7.setAutoDraw(True)
        
        # *key_resp_12* updates
        waitOnFlip = False
        if key_resp_12.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_12.frameNStart = frameN  # exact frame index
            key_resp_12.tStart = t  # local t and not account for scr refresh
            key_resp_12.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_12, 'tStartRefresh')  # time at next scr refresh
            key_resp_12.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_12.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_12.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_12.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_12.getKeys(keyList=None, waitRelease=False)
            _key_resp_12_allKeys.extend(theseKeys)
            if len(_key_resp_12_allKeys):
                key_resp_12.keys = _key_resp_12_allKeys[-1].name  # just the last key pressed
                key_resp_12.rt = _key_resp_12_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in famil_visualComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "famil_visual"-------
    for thisComponent in famil_visualComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text_7.started', text_7.tStartRefresh)
    SKIP.addData('text_7.stopped', text_7.tStopRefresh)
    # the Routine "famil_visual" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trials_5 = data.TrialHandler(nReps=1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_famil_vis.xlsx'),
        seed=None, name='trials_5')
    thisExp.addLoop(trials_5)  # add the loop to the experiment
    thisTrial_5 = trials_5.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
    if thisTrial_5 != None:
        for paramName in thisTrial_5:
            exec('{} = thisTrial_5[paramName]'.format(paramName))
    
    for thisTrial_5 in trials_5:
        currentLoop = trials_5
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
        if thisTrial_5 != None:
            for paramName in thisTrial_5:
                exec('{} = thisTrial_5[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_5.addData('text_19.started', text_19.tStartRefresh)
        trials_5.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "visualfamil"-------
        continueRoutine = True
        # update component parameters for each repeat
        movie_5 = visual.MovieStim3(
            win=win, name='movie_5',units='height', 
            noAudio = False,
            filename=melfile,
            ori=0, pos=[0, 0], opacity=1,
            loop=False,
            size=[1.4,0.9],
            depth=-2.0,
            )
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['practice_visual_start_'+thisfile])
        # keep track of which components have finished
        visualfamilComponents = [ISI_13, fixation_5, movie_5]
        for thisComponent in visualfamilComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        visualfamilClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "visualfamil"-------
        while continueRoutine:
            # get current time
            t = visualfamilClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=visualfamilClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation_5* updates
            if fixation_5.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_5.frameNStart = frameN  # exact frame index
                fixation_5.tStart = t  # local t and not account for scr refresh
                fixation_5.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_5, 'tStartRefresh')  # time at next scr refresh
                fixation_5.setAutoDraw(True)
            if fixation_5.status == STARTED:
                if bool(movie_5.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_5.tStop = t  # not accounting for scr refresh
                    fixation_5.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_5, 'tStopRefresh')  # time at next scr refresh
                    fixation_5.setAutoDraw(False)
            
            # *movie_5* updates
            if movie_5.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                movie_5.frameNStart = frameN  # exact frame index
                movie_5.tStart = t  # local t and not account for scr refresh
                movie_5.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(movie_5, 'tStartRefresh')  # time at next scr refresh
                movie_5.setAutoDraw(True)
            # *ISI_13* period
            if ISI_13.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_13.frameNStart = frameN  # exact frame index
                ISI_13.tStart = t  # local t and not account for scr refresh
                ISI_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_13, 'tStartRefresh')  # time at next scr refresh
                ISI_13.start(0.5)
            elif ISI_13.status == STARTED:  # one frame should pass before updating params and completing
                ISI_13.complete()  # finish the static period
                ISI_13.tStop = ISI_13.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in visualfamilComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "visualfamil"-------
        for thisComponent in visualfamilComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_5.addData('ISI_13.started', ISI_13.tStart)
        trials_5.addData('ISI_13.stopped', ISI_13.tStop)
        trials_5.addData('fixation_5.started', fixation_5.tStartRefresh)
        trials_5.addData('fixation_5.stopped', fixation_5.tStopRefresh)
        movie_5.stop()
        outlet.push_sample(x=['practice_visual_end_'+thisfile])
        # the Routine "visualfamil" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_5"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_12.keys = []
        response_12.rt = []
        _response_12_allKeys = []
        # keep track of which components have finished
        press_5Components = [response_12, text_14]
        for thisComponent in press_5Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_5Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_5"-------
        while continueRoutine:
            # get current time
            t = press_5Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_5Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_12* updates
            waitOnFlip = False
            if response_12.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_12.frameNStart = frameN  # exact frame index
                response_12.tStart = t  # local t and not account for scr refresh
                response_12.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_12, 'tStartRefresh')  # time at next scr refresh
                response_12.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_12.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_12.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_12.status == STARTED and not waitOnFlip:
                theseKeys = response_12.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_12_allKeys.extend(theseKeys)
                if len(_response_12_allKeys):
                    response_12.keys = _response_12_allKeys[-1].name  # just the last key pressed
                    response_12.rt = _response_12_allKeys[-1].rt
                    # was this correct?
                    if (response_12.keys == str(corrAns)) or (response_12.keys == corrAns):
                        response_12.corr = 1
                    else:
                        response_12.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_14* updates
            if text_14.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_14.frameNStart = frameN  # exact frame index
                text_14.tStart = t  # local t and not account for scr refresh
                text_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_14, 'tStartRefresh')  # time at next scr refresh
                text_14.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_5Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_5"-------
        for thisComponent in press_5Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_5.addData('text_14.started', text_14.tStartRefresh)
        trials_5.addData('text_14.stopped', text_14.tStopRefresh)
        # the Routine "press_5" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "demofeedback_vis"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_12.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_10.setColor([0,1,0])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_10.setColor([1,0,0])
          outlet.push_sample(x=['responsewrong'])
        
        feedback_10.setText(msg)
        # keep track of which components have finished
        demofeedback_visComponents = [feedback_10]
        for thisComponent in demofeedback_visComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        demofeedback_visClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "demofeedback_vis"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = demofeedback_visClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=demofeedback_visClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_10* updates
            if feedback_10.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_10.frameNStart = frameN  # exact frame index
                feedback_10.tStart = t  # local t and not account for scr refresh
                feedback_10.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_10, 'tStartRefresh')  # time at next scr refresh
                feedback_10.setAutoDraw(True)
            if feedback_10.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_10.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_10.tStop = t  # not accounting for scr refresh
                    feedback_10.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_10, 'tStopRefresh')  # time at next scr refresh
                    feedback_10.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in demofeedback_visComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "demofeedback_vis"-------
        for thisComponent in demofeedback_visComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_5.addData('feedback_10.started', feedback_10.tStartRefresh)
        trials_5.addData('feedback_10.stopped', feedback_10.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1 repeats of 'trials_5'
    
    # get names of stimulus parameters
    if trials_5.trialList in ([], [None], None):
        params = []
    else:
        params = trials_5.trialList[0].keys()
    # save data for this loop
    trials_5.saveAsExcel(filename + '.xlsx', sheetName='trials_5',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_5.saveAsText(filename + 'trials_5.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "txt_mel"-------
    continueRoutine = True
    # update component parameters for each repeat
    key_resp_13.keys = []
    key_resp_13.rt = []
    _key_resp_13_allKeys = []
    # keep track of which components have finished
    txt_melComponents = [text_9, key_resp_13]
    for thisComponent in txt_melComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    txt_melClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "txt_mel"-------
    while continueRoutine:
        # get current time
        t = txt_melClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=txt_melClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *text_9* updates
        if text_9.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_9.frameNStart = frameN  # exact frame index
            text_9.tStart = t  # local t and not account for scr refresh
            text_9.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_9, 'tStartRefresh')  # time at next scr refresh
            text_9.setAutoDraw(True)
        
        # *key_resp_13* updates
        waitOnFlip = False
        if key_resp_13.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_13.frameNStart = frameN  # exact frame index
            key_resp_13.tStart = t  # local t and not account for scr refresh
            key_resp_13.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_13, 'tStartRefresh')  # time at next scr refresh
            key_resp_13.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_13.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_13.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_13.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_13.getKeys(keyList=None, waitRelease=False)
            _key_resp_13_allKeys.extend(theseKeys)
            if len(_key_resp_13_allKeys):
                key_resp_13.keys = _key_resp_13_allKeys[-1].name  # just the last key pressed
                key_resp_13.rt = _key_resp_13_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in txt_melComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "txt_mel"-------
    for thisComponent in txt_melComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    SKIP.addData('text_9.started', text_9.tStartRefresh)
    SKIP.addData('text_9.stopped', text_9.tStopRefresh)
    # the Routine "txt_mel" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 0.0 repeats of 'SKIP'

# get names of stimulus parameters
if SKIP.trialList in ([], [None], None):
    params = []
else:
    params = SKIP.trialList[0].keys()
# save data for this loop
SKIP.saveAsExcel(filename + '.xlsx', sheetName='SKIP',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])
SKIP.saveAsText(filename + 'SKIP.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# set up handler to look after randomisation of conditions etc
trials_8 = data.TrialHandler(nReps=5.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='trials_8')
thisExp.addLoop(trials_8)  # add the loop to the experiment
thisTrial_8 = trials_8.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_8.rgb)
if thisTrial_8 != None:
    for paramName in thisTrial_8:
        exec('{} = thisTrial_8[paramName]'.format(paramName))

for thisTrial_8 in trials_8:
    currentLoop = trials_8
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_8.rgb)
    if thisTrial_8 != None:
        for paramName in thisTrial_8:
            exec('{} = thisTrial_8[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "randomizer"-------
    continueRoutine = True
    # update component parameters for each repeat
    sub_order=order[0:3]
    
    go1=sub_order[turn[0]]
    go2=sub_order[turn[1]]
    go3=sub_order[turn[2]]
    
    # keep track of which components have finished
    randomizerComponents = []
    for thisComponent in randomizerComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    randomizerClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "randomizer"-------
    while continueRoutine:
        # get current time
        t = randomizerClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=randomizerClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in randomizerComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "randomizer"-------
    for thisComponent in randomizerComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "randomizer" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trials = data.TrialHandler(nReps=go1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_main_mel.xlsx', selection=range((snrversion-1)*20,(snrversion-1)*20+20)),
        seed=None, name='trials')
    thisExp.addLoop(trials)  # add the loop to the experiment
    thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    for thisTrial in trials:
        currentLoop = trials
        # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
        if thisTrial != None:
            for paramName in thisTrial:
                exec('{} = thisTrial[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials.addData('text_19.started', text_19.tStartRefresh)
        trials.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "melmain"-------
        continueRoutine = True
        # update component parameters for each repeat
        melfamil_5.setSound(melfile, hamming=True)
        melfamil_5.setVolume(100, log=False)
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['main_baseline_start_'+thisfile])
        # keep track of which components have finished
        melmainComponents = [ISI_14, melfamil_5, fixation_6]
        for thisComponent in melmainComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        melmainClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "melmain"-------
        while continueRoutine:
            # get current time
            t = melmainClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=melmainClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # start/stop melfamil_5
            if melfamil_5.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                melfamil_5.frameNStart = frameN  # exact frame index
                melfamil_5.tStart = t  # local t and not account for scr refresh
                melfamil_5.tStartRefresh = tThisFlipGlobal  # on global time
                melfamil_5.play(when=win)  # sync with win flip
            
            # *fixation_6* updates
            if fixation_6.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_6.frameNStart = frameN  # exact frame index
                fixation_6.tStart = t  # local t and not account for scr refresh
                fixation_6.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_6, 'tStartRefresh')  # time at next scr refresh
                fixation_6.setAutoDraw(True)
            if fixation_6.status == STARTED:
                if bool(melfamil_5.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_6.tStop = t  # not accounting for scr refresh
                    fixation_6.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_6, 'tStopRefresh')  # time at next scr refresh
                    fixation_6.setAutoDraw(False)
            # *ISI_14* period
            if ISI_14.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_14.frameNStart = frameN  # exact frame index
                ISI_14.tStart = t  # local t and not account for scr refresh
                ISI_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_14, 'tStartRefresh')  # time at next scr refresh
                ISI_14.start(0.5)
            elif ISI_14.status == STARTED:  # one frame should pass before updating params and completing
                ISI_14.complete()  # finish the static period
                ISI_14.tStop = ISI_14.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in melmainComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "melmain"-------
        for thisComponent in melmainComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials.addData('ISI_14.started', ISI_14.tStart)
        trials.addData('ISI_14.stopped', ISI_14.tStop)
        melfamil_5.stop()  # ensure sound has stopped at end of routine
        trials.addData('melfamil_5.started', melfamil_5.tStartRefresh)
        trials.addData('melfamil_5.stopped', melfamil_5.tStopRefresh)
        trials.addData('fixation_6.started', fixation_6.tStartRefresh)
        trials.addData('fixation_6.stopped', fixation_6.tStopRefresh)
        outlet.push_sample(x=['main_baseline_end_'+thisfile])
        # the Routine "melmain" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_6"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_13.keys = []
        response_13.rt = []
        _response_13_allKeys = []
        # keep track of which components have finished
        press_6Components = [response_13, text_15]
        for thisComponent in press_6Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_6Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_6"-------
        while continueRoutine:
            # get current time
            t = press_6Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_6Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_13* updates
            waitOnFlip = False
            if response_13.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_13.frameNStart = frameN  # exact frame index
                response_13.tStart = t  # local t and not account for scr refresh
                response_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_13, 'tStartRefresh')  # time at next scr refresh
                response_13.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_13.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_13.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_13.status == STARTED and not waitOnFlip:
                theseKeys = response_13.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_13_allKeys.extend(theseKeys)
                if len(_response_13_allKeys):
                    response_13.keys = _response_13_allKeys[-1].name  # just the last key pressed
                    response_13.rt = _response_13_allKeys[-1].rt
                    # was this correct?
                    if (response_13.keys == str(corrAns)) or (response_13.keys == corrAns):
                        response_13.corr = 1
                    else:
                        response_13.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_15* updates
            if text_15.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_15.frameNStart = frameN  # exact frame index
                text_15.tStart = t  # local t and not account for scr refresh
                text_15.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_15, 'tStartRefresh')  # time at next scr refresh
                text_15.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_6Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_6"-------
        for thisComponent in press_6Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials.addData('text_15.started', text_15.tStartRefresh)
        trials.addData('text_15.stopped', text_15.tStopRefresh)
        # the Routine "press_6" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "mainfeedback_mel"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_13.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_11.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_11.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsewrong'])
        feedback_11.setText(msg)
        # keep track of which components have finished
        mainfeedback_melComponents = [feedback_11]
        for thisComponent in mainfeedback_melComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        mainfeedback_melClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "mainfeedback_mel"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = mainfeedback_melClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=mainfeedback_melClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_11* updates
            if feedback_11.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_11.frameNStart = frameN  # exact frame index
                feedback_11.tStart = t  # local t and not account for scr refresh
                feedback_11.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_11, 'tStartRefresh')  # time at next scr refresh
                feedback_11.setAutoDraw(True)
            if feedback_11.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_11.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_11.tStop = t  # not accounting for scr refresh
                    feedback_11.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_11, 'tStopRefresh')  # time at next scr refresh
                    feedback_11.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in mainfeedback_melComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "mainfeedback_mel"-------
        for thisComponent in mainfeedback_melComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials.addData('feedback_11.started', feedback_11.tStartRefresh)
        trials.addData('feedback_11.stopped', feedback_11.tStopRefresh)
        thisExp.nextEntry()
        
    # completed go1 repeats of 'trials'
    
    # get names of stimulus parameters
    if trials.trialList in ([], [None], None):
        params = []
    else:
        params = trials.trialList[0].keys()
    # save data for this loop
    trials.saveAsExcel(filename + '.xlsx', sheetName='trials',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials.saveAsText(filename + 'trials.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # set up handler to look after randomisation of conditions etc
    trials_6 = data.TrialHandler(nReps=go2, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_main_pred.xlsx', selection=range((snrversion-1)*20,(snrversion-1)*20+20)),
        seed=None, name='trials_6')
    thisExp.addLoop(trials_6)  # add the loop to the experiment
    thisTrial_6 = trials_6.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
    if thisTrial_6 != None:
        for paramName in thisTrial_6:
            exec('{} = thisTrial_6[paramName]'.format(paramName))
    
    for thisTrial_6 in trials_6:
        currentLoop = trials_6
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
        if thisTrial_6 != None:
            for paramName in thisTrial_6:
                exec('{} = thisTrial_6[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_6.addData('text_19.started', text_19.tStartRefresh)
        trials_6.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "predictmain"-------
        continueRoutine = True
        # update component parameters for each repeat
        melfamil_6.setSound(melfile, hamming=True)
        melfamil_6.setVolume(100, log=False)
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['main_predict_start_'+thisfile])
        # keep track of which components have finished
        predictmainComponents = [ISI_15, melfamil_6, fixation_7]
        for thisComponent in predictmainComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        predictmainClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "predictmain"-------
        while continueRoutine:
            # get current time
            t = predictmainClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=predictmainClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # start/stop melfamil_6
            if melfamil_6.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                melfamil_6.frameNStart = frameN  # exact frame index
                melfamil_6.tStart = t  # local t and not account for scr refresh
                melfamil_6.tStartRefresh = tThisFlipGlobal  # on global time
                melfamil_6.play(when=win)  # sync with win flip
            
            # *fixation_7* updates
            if fixation_7.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_7.frameNStart = frameN  # exact frame index
                fixation_7.tStart = t  # local t and not account for scr refresh
                fixation_7.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_7, 'tStartRefresh')  # time at next scr refresh
                fixation_7.setAutoDraw(True)
            if fixation_7.status == STARTED:
                if bool(melfamil_6.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_7.tStop = t  # not accounting for scr refresh
                    fixation_7.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_7, 'tStopRefresh')  # time at next scr refresh
                    fixation_7.setAutoDraw(False)
            # *ISI_15* period
            if ISI_15.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_15.frameNStart = frameN  # exact frame index
                ISI_15.tStart = t  # local t and not account for scr refresh
                ISI_15.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_15, 'tStartRefresh')  # time at next scr refresh
                ISI_15.start(0.5)
            elif ISI_15.status == STARTED:  # one frame should pass before updating params and completing
                ISI_15.complete()  # finish the static period
                ISI_15.tStop = ISI_15.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in predictmainComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "predictmain"-------
        for thisComponent in predictmainComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_6.addData('ISI_15.started', ISI_15.tStart)
        trials_6.addData('ISI_15.stopped', ISI_15.tStop)
        melfamil_6.stop()  # ensure sound has stopped at end of routine
        trials_6.addData('melfamil_6.started', melfamil_6.tStartRefresh)
        trials_6.addData('melfamil_6.stopped', melfamil_6.tStopRefresh)
        trials_6.addData('fixation_7.started', fixation_7.tStartRefresh)
        trials_6.addData('fixation_7.stopped', fixation_7.tStopRefresh)
        outlet.push_sample(x=['main_predict_end_'+thisfile])
        # the Routine "predictmain" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_7"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_14.keys = []
        response_14.rt = []
        _response_14_allKeys = []
        # keep track of which components have finished
        press_7Components = [response_14, text_20]
        for thisComponent in press_7Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_7Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_7"-------
        while continueRoutine:
            # get current time
            t = press_7Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_7Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_14* updates
            waitOnFlip = False
            if response_14.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_14.frameNStart = frameN  # exact frame index
                response_14.tStart = t  # local t and not account for scr refresh
                response_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_14, 'tStartRefresh')  # time at next scr refresh
                response_14.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_14.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_14.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_14.status == STARTED and not waitOnFlip:
                theseKeys = response_14.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_14_allKeys.extend(theseKeys)
                if len(_response_14_allKeys):
                    response_14.keys = _response_14_allKeys[-1].name  # just the last key pressed
                    response_14.rt = _response_14_allKeys[-1].rt
                    # was this correct?
                    if (response_14.keys == str(corrAns)) or (response_14.keys == corrAns):
                        response_14.corr = 1
                    else:
                        response_14.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_20* updates
            if text_20.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_20.frameNStart = frameN  # exact frame index
                text_20.tStart = t  # local t and not account for scr refresh
                text_20.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_20, 'tStartRefresh')  # time at next scr refresh
                text_20.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_7Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_7"-------
        for thisComponent in press_7Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_6.addData('text_20.started', text_20.tStartRefresh)
        trials_6.addData('text_20.stopped', text_20.tStopRefresh)
        # the Routine "press_7" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "mainfeedback_predict"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_14.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_12.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_12.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsewrong'])
        
        
        
        feedback_12.setText(msg)
        # keep track of which components have finished
        mainfeedback_predictComponents = [feedback_12]
        for thisComponent in mainfeedback_predictComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        mainfeedback_predictClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "mainfeedback_predict"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = mainfeedback_predictClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=mainfeedback_predictClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_12* updates
            if feedback_12.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_12.frameNStart = frameN  # exact frame index
                feedback_12.tStart = t  # local t and not account for scr refresh
                feedback_12.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_12, 'tStartRefresh')  # time at next scr refresh
                feedback_12.setAutoDraw(True)
            if feedback_12.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_12.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_12.tStop = t  # not accounting for scr refresh
                    feedback_12.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_12, 'tStopRefresh')  # time at next scr refresh
                    feedback_12.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in mainfeedback_predictComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "mainfeedback_predict"-------
        for thisComponent in mainfeedback_predictComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_6.addData('feedback_12.started', feedback_12.tStartRefresh)
        trials_6.addData('feedback_12.stopped', feedback_12.tStopRefresh)
        thisExp.nextEntry()
        
    # completed go2 repeats of 'trials_6'
    
    # get names of stimulus parameters
    if trials_6.trialList in ([], [None], None):
        params = []
    else:
        params = trials_6.trialList[0].keys()
    # save data for this loop
    trials_6.saveAsExcel(filename + '.xlsx', sheetName='trials_6',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_6.saveAsText(filename + 'trials_6.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # set up handler to look after randomisation of conditions etc
    trials_10 = data.TrialHandler(nReps=go3, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('conditions_main_vis_lum.xlsx', selection=range((snrversion-1)*20,(snrversion-1)*20+20)),
        seed=None, name='trials_10')
    thisExp.addLoop(trials_10)  # add the loop to the experiment
    thisTrial_10 = trials_10.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_10.rgb)
    if thisTrial_10 != None:
        for paramName in thisTrial_10:
            exec('{} = thisTrial_10[paramName]'.format(paramName))
    
    for thisTrial_10 in trials_10:
        currentLoop = trials_10
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_10.rgb)
        if thisTrial_10 != None:
            for paramName in thisTrial_10:
                exec('{} = thisTrial_10[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "basefix"-------
        continueRoutine = True
        routineTimer.add(3.000000)
        # update component parameters for each repeat
        outlet.push_sample(x=['basefixstart'])
        # keep track of which components have finished
        basefixComponents = [text_19]
        for thisComponent in basefixComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        basefixClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "basefix"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = basefixClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=basefixClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_19* updates
            if text_19.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_19.frameNStart = frameN  # exact frame index
                text_19.tStart = t  # local t and not account for scr refresh
                text_19.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_19, 'tStartRefresh')  # time at next scr refresh
                text_19.setAutoDraw(True)
            if text_19.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > text_19.tStartRefresh + 3-frameTolerance:
                    # keep track of stop time/frame for later
                    text_19.tStop = t  # not accounting for scr refresh
                    text_19.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(text_19, 'tStopRefresh')  # time at next scr refresh
                    text_19.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in basefixComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "basefix"-------
        for thisComponent in basefixComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_10.addData('text_19.started', text_19.tStartRefresh)
        trials_10.addData('text_19.stopped', text_19.tStopRefresh)
        
        # ------Prepare to start Routine "visualmain"-------
        continueRoutine = True
        # update component parameters for each repeat
        movie_7 = visual.MovieStim3(
            win=win, name='movie_7',units='height', 
            noAudio = False,
            filename=melfile,
            ori=0, pos=[0, 0], opacity=1,
            loop=False,
            size=[1.4,0.9],
            depth=-2.0,
            )
        thisfile = os.path.basename(melfile)
        outlet.push_sample(x=['main_visual_start_'+thisfile])
        # keep track of which components have finished
        visualmainComponents = [ISI_18, fixation_10, movie_7]
        for thisComponent in visualmainComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        visualmainClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "visualmain"-------
        while continueRoutine:
            # get current time
            t = visualmainClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=visualmainClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation_10* updates
            if fixation_10.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_10.frameNStart = frameN  # exact frame index
                fixation_10.tStart = t  # local t and not account for scr refresh
                fixation_10.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_10, 'tStartRefresh')  # time at next scr refresh
                fixation_10.setAutoDraw(True)
            if fixation_10.status == STARTED:
                if bool(movie_7.status == FINISHED):
                    # keep track of stop time/frame for later
                    fixation_10.tStop = t  # not accounting for scr refresh
                    fixation_10.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_10, 'tStopRefresh')  # time at next scr refresh
                    fixation_10.setAutoDraw(False)
            
            # *movie_7* updates
            if movie_7.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                movie_7.frameNStart = frameN  # exact frame index
                movie_7.tStart = t  # local t and not account for scr refresh
                movie_7.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(movie_7, 'tStartRefresh')  # time at next scr refresh
                movie_7.setAutoDraw(True)
            # *ISI_18* period
            if ISI_18.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                ISI_18.frameNStart = frameN  # exact frame index
                ISI_18.tStart = t  # local t and not account for scr refresh
                ISI_18.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(ISI_18, 'tStartRefresh')  # time at next scr refresh
                ISI_18.start(0.5)
            elif ISI_18.status == STARTED:  # one frame should pass before updating params and completing
                ISI_18.complete()  # finish the static period
                ISI_18.tStop = ISI_18.tStart + 0.5  # record stop time
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in visualmainComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "visualmain"-------
        for thisComponent in visualmainComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_10.addData('ISI_18.started', ISI_18.tStart)
        trials_10.addData('ISI_18.stopped', ISI_18.tStop)
        trials_10.addData('fixation_10.started', fixation_10.tStartRefresh)
        trials_10.addData('fixation_10.stopped', fixation_10.tStopRefresh)
        movie_7.stop()
        outlet.push_sample(x=['main_visual_end_'+thisfile])
        # the Routine "visualmain" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "press_10"-------
        continueRoutine = True
        # update component parameters for each repeat
        response_17.keys = []
        response_17.rt = []
        _response_17_allKeys = []
        # keep track of which components have finished
        press_10Components = [response_17, text_18]
        for thisComponent in press_10Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        press_10Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "press_10"-------
        while continueRoutine:
            # get current time
            t = press_10Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=press_10Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *response_17* updates
            waitOnFlip = False
            if response_17.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                response_17.frameNStart = frameN  # exact frame index
                response_17.tStart = t  # local t and not account for scr refresh
                response_17.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_17, 'tStartRefresh')  # time at next scr refresh
                response_17.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_17.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_17.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_17.status == STARTED and not waitOnFlip:
                theseKeys = response_17.getKeys(keyList=['q', 'p'], waitRelease=False)
                _response_17_allKeys.extend(theseKeys)
                if len(_response_17_allKeys):
                    response_17.keys = _response_17_allKeys[-1].name  # just the last key pressed
                    response_17.rt = _response_17_allKeys[-1].rt
                    # was this correct?
                    if (response_17.keys == str(corrAns)) or (response_17.keys == corrAns):
                        response_17.corr = 1
                    else:
                        response_17.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *text_18* updates
            if text_18.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_18.frameNStart = frameN  # exact frame index
                text_18.tStart = t  # local t and not account for scr refresh
                text_18.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_18, 'tStartRefresh')  # time at next scr refresh
                text_18.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in press_10Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "press_10"-------
        for thisComponent in press_10Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_10.addData('text_18.started', text_18.tStartRefresh)
        trials_10.addData('text_18.stopped', text_18.tStopRefresh)
        # the Routine "press_10" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "mainfeedback_visual"-------
        continueRoutine = True
        routineTimer.add(1.000000)
        # update component parameters for each repeat
        if response_17.corr:#stored on last run routine
          msg=ifCorrTxt
          feedback_15.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsecorrect'])
        else:
          msg=ifIncorrTxt
          feedback_15.setColor([0.8,0.8,0.8])
          outlet.push_sample(x=['responsewrong'])
          
        
        
        feedback_15.setText(msg)
        # keep track of which components have finished
        mainfeedback_visualComponents = [feedback_15]
        for thisComponent in mainfeedback_visualComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        mainfeedback_visualClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "mainfeedback_visual"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = mainfeedback_visualClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=mainfeedback_visualClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *feedback_15* updates
            if feedback_15.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                feedback_15.frameNStart = frameN  # exact frame index
                feedback_15.tStart = t  # local t and not account for scr refresh
                feedback_15.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(feedback_15, 'tStartRefresh')  # time at next scr refresh
                feedback_15.setAutoDraw(True)
            if feedback_15.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > feedback_15.tStartRefresh + 1.0-frameTolerance:
                    # keep track of stop time/frame for later
                    feedback_15.tStop = t  # not accounting for scr refresh
                    feedback_15.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(feedback_15, 'tStopRefresh')  # time at next scr refresh
                    feedback_15.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in mainfeedback_visualComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "mainfeedback_visual"-------
        for thisComponent in mainfeedback_visualComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_10.addData('feedback_15.started', feedback_15.tStartRefresh)
        trials_10.addData('feedback_15.stopped', feedback_15.tStopRefresh)
        thisExp.nextEntry()
        
    # completed go3 repeats of 'trials_10'
    
    # get names of stimulus parameters
    if trials_10.trialList in ([], [None], None):
        params = []
    else:
        params = trials_10.trialList[0].keys()
    # save data for this loop
    trials_10.saveAsExcel(filename + '.xlsx', sheetName='trials_10',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_10.saveAsText(filename + 'trials_10.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    
    # ------Prepare to start Routine "deleter"-------
    continueRoutine = True
    # update component parameters for each repeat
    # keep track of which components have finished
    deleterComponents = []
    for thisComponent in deleterComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    deleterClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "deleter"-------
    while continueRoutine:
        # get current time
        t = deleterClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=deleterClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in deleterComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "deleter"-------
    for thisComponent in deleterComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    order.remove(order[2])
    order.remove(order[1])
    order.remove(order[0])
    # the Routine "deleter" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 5.0 repeats of 'trials_8'

# get names of stimulus parameters
if trials_8.trialList in ([], [None], None):
    params = []
else:
    params = trials_8.trialList[0].keys()
# save data for this loop
trials_8.saveAsExcel(filename + '.xlsx', sheetName='trials_8',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])
trials_8.saveAsText(filename + 'trials_8.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "finaltext"-------
continueRoutine = True
routineTimer.add(1.000000)
# update component parameters for each repeat
outlet.push_sample(x=['experiment complete'])

# keep track of which components have finished
finaltextComponents = [endtext]
for thisComponent in finaltextComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
finaltextClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "finaltext"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = finaltextClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=finaltextClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *endtext* updates
    if endtext.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        endtext.frameNStart = frameN  # exact frame index
        endtext.tStart = t  # local t and not account for scr refresh
        endtext.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(endtext, 'tStartRefresh')  # time at next scr refresh
        endtext.setAutoDraw(True)
    if endtext.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > endtext.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            endtext.tStop = t  # not accounting for scr refresh
            endtext.frameNStop = frameN  # exact frame index
            win.timeOnFlip(endtext, 'tStopRefresh')  # time at next scr refresh
            endtext.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in finaltextComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "finaltext"-------
for thisComponent in finaltextComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('endtext.started', endtext.tStartRefresh)
thisExp.addData('endtext.stopped', endtext.tStopRefresh)

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
